#!/bin/bash

CMDNAME=`basename $0`
FLG_J=""

while getopts ag:m:j:h OPT
do
  case $OPT in
    "a" ) FLG_A="TRUE" ;;
    "m" ) FLG_M=${OPTARG} ;;
    "j" ) FLG_J=${OPTARG} ;;
    "g" ) FLG_G=${OPTARG} ;;
      * ) echo "Usage: $CMDNAME [-a] [-m 64] [-j n] [-g optimizeflag]" 1>&2
          exit 1 ;;
  esac
done

if [ "$FLG_M" = "64" ] ; then
    ARCH="-m64";
else
    ARCH="-m32";
fi

if [ "$FLG_J" = "" ] ; then
    PARAMK=""
else
    PARAMK="-j$FLG_J"
fi

if [ "$FLG_G" = "" ] ; then
    MKOPT="-O2"
else
    MKOPT="$FLG_G"
fi

if [ "$FLG_A" = "TRUE" ] ; then
    pushd win32 ; make clean ; make ARCH=$ARCH OPT=$MKOPT $PARAMK ; popd ;
fi
pushd win32frame ; make clean ; make ARCH=$ARCH OPT=$MKOPT $PARAMK ; popd ;
pushd util ; make clean ; make ARCH=$ARCH OPT=$MKOPT $PARAMK ; popd ;
make clean ; make ARCH=$ARCH OPT=$MKOPT $PARAMK
