import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.Frame;
import win32frame.WindowMenu;
import win32frame.StatusBar;
import win32frame.ToolBarEx;
import win32frame.Rebar;
import win32frame.PushButton;
import win32frame.MainWindow ;
import win32frame.MsgBox;
import win32frame.FileDialog;
import win32frame.FontSelDialog ;
import win32frame.ColorSelDialog ;
import std.stdio;
import std.string;
import std.utf;

import FontMan;
import TestDialog;
import MyButton ;
import MainPanel ;

enum FILE{
  ROOT  =0x100,
  OPEN  =0x101,
  CLOSE =0x102,
  EXIT  =0x103
} ;
enum EDIT{
  ROOT  =0x200,
  CUT   =0x201,
  COPY  =0x202,
  PASTE =0x203
} ;

enum CMD{
  OPENTESTDLG    =0xa00,
  OPENFONTSELDLG =0xa01,
  OPENCOLSELDLG  =0xa02,
} ;

enum TOOLBAR{
  ROOT    =0x500,
  NEWFILE =0x501,
  FOPEN   =0x502,
  FSAVE   =0x503,
  ECOPY   =0x504,
  ECUT    =0x505,
  EDEL    =0x506
} ;
  

class myMainWindow : MainWindow {
  WindowMenu  menuroot ;
  StatusBar   statusbar ;
  ToolBarEx   toolbarex ;
  TBBUTTON[]  tbButton ;
  MainPanel   mainpanel ;
  MyButton    tdlogbtn ;
  MyButton    fontselbtn ;
  MyButton    colselbtn ;

  HFONT       hfont_v14;
  HFONT       selfont ;
  LOGFONT     logfont ;

  this(string name, string ClassName) {
    winc.style          = 0;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = LoadIcon(GetModuleHandle(null), toUTFz!(wchar*)("WAPICON"));
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    //winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = toUTFz!(wchar*)(ClassName) ;
    super(name,ClassName) ;
    
    tbButton.length = 7 ;
    tbButton[0].iBitmap=STD_FILENEW  ; tbButton[0].idCommand=TOOLBAR.NEWFILE ; tbButton[0].fsState=TBSTATE_ENABLED ; tbButton[0].fsStyle=TBSTYLE_BUTTON ;
    tbButton[1].iBitmap=STD_FILEOPEN ; tbButton[1].idCommand=TOOLBAR.FOPEN   ; tbButton[1].fsState=TBSTATE_ENABLED ; tbButton[1].fsStyle=TBSTYLE_BUTTON ;
    tbButton[2].iBitmap=STD_FILESAVE ; tbButton[2].idCommand=TOOLBAR.FSAVE   ; tbButton[2].fsState=TBSTATE_ENABLED ; tbButton[2].fsStyle=TBSTYLE_BUTTON ;
    tbButton[3].iBitmap=0            ; tbButton[3].idCommand=0               ; tbButton[3].fsState=TBSTATE_ENABLED ; tbButton[3].fsStyle=TBSTYLE_SEP    ;
    tbButton[4].iBitmap=STD_COPY     ; tbButton[4].idCommand=TOOLBAR.ECOPY   ; tbButton[4].fsState=TBSTATE_ENABLED ; tbButton[4].fsStyle=TBSTYLE_BUTTON ;
    tbButton[5].iBitmap=STD_CUT      ; tbButton[5].idCommand=TOOLBAR.ECUT    ; tbButton[5].fsState=TBSTATE_ENABLED ; tbButton[5].fsStyle=TBSTYLE_BUTTON ;
    tbButton[6].iBitmap=STD_DELETE   ; tbButton[6].idCommand=TOOLBAR.EDEL    ; tbButton[6].fsState=TBSTATE_ENABLED ; tbButton[6].fsStyle=TBSTYLE_BUTTON ;

    logfont.lfHeight         = 12 ;
    logfont.lfWidth          =  0 ;
    logfont.lfEscapement     =  0 ;
    logfont.lfOrientation    =  0 ;
    logfont.lfWeight         = FW_REGULAR ;
    logfont.lfItalic         = false ;
    logfont.lfUnderline      = false ;
    logfont.lfStrikeOut      = false ;
    logfont.lfCharSet        = DEFAULT_CHARSET ;
    logfont.lfOutPrecision   = OUT_DEFAULT_PRECIS ;
    logfont.lfClipPrecision  = CLIP_DEFAULT_PRECIS ;
    logfont.lfQuality        = DEFAULT_QUALITY ;
    logfont.lfPitchAndFamily = FIXED_PITCH ;
    wstring facename = "ＭＳ ゴシック\0" ;
    wchar[] fn=facename.dup ;
    logfont.lfFaceName[0..fn.length] = fn[0..$] ;    
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      DeleteObject(hfont_v14);
      DeleteObject(selfont) ;
      PostQuitMessage(0);
      break ;
      
    case WM_CREATE:
      menuroot = new WindowMenu() ;
      menuroot.create() ;
      menuroot.addMenu(             MFT_STRING, "File"     , FILE.ROOT ) ;
      menuroot.addItem( "File",     MFT_STRING, "Open"     , FILE.OPEN ) ;
      menuroot.addItem( "File",     MFT_STRING, "Close"    , FILE.CLOSE) ;
      menuroot.addItem( "File",     MFT_STRING, "Exit"     , FILE.EXIT ) ;
      menuroot.addMenu(             MFT_STRING, "Edit"     , EDIT.ROOT ) ;
      menuroot.addItem( "Edit",     MFT_STRING, "Cut"      , EDIT.CUT  ) ;
      menuroot.addItem( "Edit",     MFT_STRING, "Copy"     , EDIT.COPY ) ;
      menuroot.addItem( "Edit",     MFT_STRING, "Paste"    , EDIT.PASTE) ;
      
      setMenu(menuroot) ;
      
      statusbar = new StatusBar() ;
      statusbar.addStyle(CCS_BOTTOM | SBARS_SIZEGRIP) ;
      addStatusBar(statusbar, "") ;
      
      FontMan font_v14 ; font_v14.init(14,VARIABLE_PITCH) ;
      hfont_v14 = font_v14.createHFONT() ;

      selfont = CreateFontIndirect(&logfont);
      
      toolbarex = new ToolBarEx() ;
      toolbarex.addStyle(CCS_ADJUSTABLE|TBSTYLE_FLAT|CCS_NOPARENTALIGN|CCS_NORESIZE|CCS_NODIVIDER) ;
      toolbarex.create(hwnd, TOOLBAR.ROOT, 0, tbButton, cast(int)(tbButton.length)) ;
      addonRebar(toolbarex) ;

      tdlogbtn= new MyButton("OpenTestDialog") ;
      tdlogbtn.setPosition(0,20,100,20) ;
      //tdlogbtn.setFlatMode(true) ;
      addObject(tdlogbtn, cast(HMENU)(CMD.OPENTESTDLG)) ;
      addonRebar(tdlogbtn) ;
      tdlogbtn.setFont(hfont_v14) ;
      
      fontselbtn= new MyButton("FontSelectDialog") ;
      fontselbtn.setPosition(0,20,100,20) ;
      fontselbtn.setFlatMode(true,true) ;
      addObject(fontselbtn, cast(HMENU)(CMD.OPENFONTSELDLG)) ;
      addonRebar(fontselbtn) ;
      fontselbtn.setFont(selfont) ;
      
      colselbtn= new MyButton("ColSelectDialog") ;
      colselbtn.setPosition(0,20,100,20) ;
      colselbtn.setFlatMode(true,true) ;
      addObject(colselbtn, cast(HMENU)(CMD.OPENCOLSELDLG)) ;
      addonRebar(colselbtn) ;
      colselbtn.setFont(hfont_v14) ;
      
      mainpanel = new MainPanel("MainPanel","MainPanelTest") ;
      mainpanel.setPosition(0,0,200,200) ;
      mainpanel.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      addObject( mainpanel, null, true, true ) ;
      break ;
      
    case WM_COMMAND:
      switch( LOWORD(wp) ){
      case TOOLBAR.FOPEN :
      case FILE.OPEN :
	FileDialog fdlog = new FileDialog() ;
	string     fname = fdlog.getLoadFileName("JPEG {*.JPG}\0*.jpg\0PNG {*.PNG}\0*.png\0",hwnd,OFN_HIDEREADONLY) ;
        if( fname.length!=0 ){
          if( this.mainpanel.subpanel2.LoadImage(fname)==0 ){
	    printStatusbar( format("%sを開きました",fname) ) ;
	  }
	}
	break ;
      
      case FILE.EXIT :
	int    msgbox_ret ;
	MsgBox msgbox ;
	msgbox = new MsgBox(hwnd, "終了しますか？", "確認", MB_YESNO ) ;
	msgbox_ret = msgbox.create() ;
	if( msgbox_ret==IDYES ){
	  sendmsg(WM_CLOSE, 0,0) ;
	}
	break ;
	
      case CMD.OPENTESTDLG :
	auto dlogbox = new TestDialog("TestDialog", "DialogBox") ;
	dlogbox.Create( winX+100, winY+100, hwnd, null ) ;
	int dlgret = dlogbox.getDlogResult() ;
	int chkret = dlogbox.getCheckState() ;
	double spinvalue = dlogbox.getSpinValue() ;
	printStatusbar( format("dlog_result=%x / CheckState=%x / SpinValue=%f",dlgret,chkret,spinvalue) ) ;
	clear(dlogbox) ;
	break ;

      case CMD.OPENFONTSELDLG :
        CHOOSEFONT cf ;
        cf.lpLogFont = &logfont ;
        cf.hwndOwner = hwnd ;
        cf.Flags     = CF_FIXEDPITCHONLY | CF_SCREENFONTS | CF_NOVERTFONTS | CF_INITTOLOGFONTSTRUCT | CF_SELECTSCRIPT ;
        auto fontsel = new FontSelDialog() ;
        if( fontsel.chooseFont(&cf)==true ){
	  if( selfont!=null ) DeleteObject(selfont) ;
	  selfont = CreateFontIndirect(&logfont);
	  fontselbtn.setFont(selfont) ;
        }
	break ;
	
      case CMD.OPENCOLSELDLG :
	CHOOSECOLOR  cc ;
	COLORREF     color ;
	COLORREF[16] collist ;
	cc.hwndOwner = hwnd ;
	cc.Flags     = CC_FULLOPEN | CC_RGBINIT | CC_PREVENTFULLOPEN ;
	cc.rgbResult = color ;
	cc.lpCustColors = collist.ptr ;
	auto colsel = new ColorSelDialog() ;
        if( colsel.chooseColor(&cc)==true ){
	  colselbtn.setStringColor(cc.rgbResult) ;
        }
	break ;
	
      case TOOLBAR.NEWFILE :
	printStatusbar( "ToolBar NewFile" ) ;
	break ;
      case TOOLBAR.FSAVE :
	printStatusbar( "ToolBar FileSave" ) ;
	break ;
      case TOOLBAR.ECOPY :
	printStatusbar( "ToolBar Copy" ) ;
	break ;
      case TOOLBAR.ECUT :
	printStatusbar( "ToolBar Cut" ) ;
	break ;
      case TOOLBAR.EDEL :
	printStatusbar( "ToolBar Delete" ) ;
	break ;

      case FILE.CLOSE :
	printStatusbar( "Menu File Close" ) ;
	break ;
      case EDIT.CUT :
	printStatusbar( "Menu Edit Cut" ) ;
	break ;
      case EDIT.COPY :
	printStatusbar( "Menu Edit Copy" ) ;
	break ;
      case EDIT.PASTE :
	printStatusbar( "Menu Edit Paste" ) ;
	break ;
	
      default :
	break ;
      }
      break;
      
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }
}
